﻿#region usings
using System;
using System.ComponentModel.Composition;
using System.Collections.Generic;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
    #region PluginInfo
    [PluginInfo(Name = "controlManager", Category = "controlManager", Help = "Basic template with one value in/out", Tags = "")]
    #endregion PluginInfo
    public class ControlManager : IPluginEvaluate
    {
        #region fields & pins
       
        [Output("controlDict")]
        ISpread<ControlSet> controlOut;

        [Output("Available Transforms")]
        ISpread<string> avTransforms;

        [Output("Available Values")]
        ISpread<string> avValues;

        [Output("Available Colors")]
        ISpread<string> avColors;

        [Output("Available Strings")]
        ISpread<string> avStrings;


        [Import()]
        ILogger FLogger;
        #endregion fields & pins

        //called when data for any output pin is requested
        public static Dictionary<string, ControlSet> transformDict = new Dictionary<string, ControlSet>();
        //public static Dictionary<string, ControlSetString> colorDict = new Dictionary<string, ControlSetString>();
        public static Dictionary<string, ControlSet> valueDict = new Dictionary<string, ControlSet>();
        public static Dictionary<string, ControlSet> stringDict = new Dictionary<string, ControlSet>();
        public static List<string> availableTransforms = new List<string>();
        public static List<string> availableColors = new List<string>();
        public static List<string> availableValues = new List<string>();
        public static List<string> availableStrings = new List<string>();
        int SetCount = 0;

        public void Evaluate(int SpreadMax)
        {
            SetCount = 0;
            availableValues.Clear();
            loopDictAndOutput(valueDict, avValues, availableValues);
            loopDictAndOutput(stringDict, avStrings, availableStrings);
            loopDictAndOutput(transformDict, avTransforms, availableTransforms);
            
         
        }

        private void loopDictAndOutput(Dictionary<string, ControlSet> dict, ISpread<string> outPin, List<string> avList) {
            int count = 0;
            avList.Clear();
            foreach (var colSet in dict)
            {
                
                controlOut.SliceCount = SetCount+1;
                controlOut[SetCount] = colSet.Value;
                
                outPin.SliceCount = count + 1;
                outPin[count] = colSet.Value.getName();
                avList.Add(colSet.Value.getName());
                
                SetCount++;
                count++;
                
            }
        
        }

    }
}