﻿#region usings
using System;
using System.ComponentModel.Composition;
using System.ComponentModel.Composition;
using System.Collections.Generic;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
    #region PluginInfo
    [PluginInfo(Name = "getControlString", Category = "controlManager", Help = "Gets a String from the ControlManager", Tags = "")]
    #endregion PluginInfo
    public class GetControlEntryString : IPluginEvaluate
    {
        #region fields & pins
        [Input("ControlSetsIn", DefaultValue = 1.0)]
        ISpread<ControlSet> ControlSetsIn;

        [Input("Selection", DefaultValue = 1.0)]
        ISpread<String> SelectionIn;

        [Output("Value Out ")]
        ISpread<string> FValueOut;

        [Output("Available Values")]
        ISpread<string> FNameOut;

        [Import()]
        ILogger FLogger;
        #endregion fields & pins

        //called when data for any output pin is requested
        public void Evaluate(int SpreadMax)
        {

            for (int i = 0; i < SpreadMax; i++)
            {
                if (SelectionIn[0] == ControlSetsIn[i].getName() && ControlSetsIn[i] is ControlSetString)
                {
                    Dictionary<int, String> tempDict = ((ControlSetString) ControlSetsIn[i]).getDict();
                    foreach (var pair in tempDict)
                    {
                        FValueOut.SliceCount = pair.Key + 1;
                        FValueOut[pair.Key] = pair.Value.ToString();
                    }

                };
            }
            int counter = 0;
            foreach (string key in ControlManager.availableStrings)
            {
                FNameOut.SliceCount = counter + 1;
                FNameOut[counter] = key;
                counter++;
            }
        }
    }
}
