﻿#region usings
using System;
using System.ComponentModel.Composition;
using System.ComponentModel.Composition;
using System.Collections.Generic;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
    #region PluginInfo
    [PluginInfo(Name = "getControlValue", Category = "controlManager", Help = "Gets a Value from the ControlManager", Tags = "")]
    #endregion PluginInfo
    public class GetControlEntryValue : IPluginEvaluate
    {
        #region fields & pins
        [Input("ControlSetsIn", DefaultValue = 1.0)]
        ISpread<ControlSet> ControlSetsIn;

        [Input("Selection", DefaultValue = 1.0)]
        ISpread<String> SelectionIn;

        [Output("Value Out ")]
        ISpread<double> FValueOut;
        
        [Output("Available Values")]
        ISpread<string> FNameOut;

        [Import()]
        ILogger FLogger;
        #endregion fields & pins

        //called when data for any output pin is requested
        public void Evaluate(int SpreadMax)
        {
     
            for (int i = 0; i < SpreadMax; i++) {


                if (SelectionIn[0] == ControlSetsIn[i].getName() && ControlSetsIn[i].getType() == ControlSetValue.CSVALUE) {

                    FLogger.Log(LogType.Debug, "found entry");
                    Dictionary<int, double> tempDict = ((ControlSetValue)ControlSetsIn[i]).getDict();
                    foreach (var pair in tempDict) {
                        FValueOut.SliceCount = pair.Key+1;
                        FValueOut[pair.Key] =  Helper.ToDouble(pair.Value.ToString());
                    }
                
                };
            }
            int counter = 0;
            foreach(string key in ControlManager.availableValues){
                FNameOut.SliceCount = counter+1;
                FNameOut[counter] = key;
                counter++;
            }
        }
    }
}
