﻿#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
    #region PluginInfo
    [PluginInfo(Name = "setControlString", Category = "controlManager", Help = "Sets a String to the ControlManager", Tags = "", AutoEvaluate = true)]
    #endregion PluginInfo
    public class SetControlEntryString : IPluginEvaluate
    {
        #region fields & pins
        [Input("Value", DefaultValue = 1.0)]
        IDiffSpread<string> FValueIn;

        [Input("Name", DefaultValue = 1.0)]
        IDiffSpread<string> FNameIn;

        [Output("debug", DefaultValue = 1.0)]
        ISpread<string> debugOut;

        [Import()]
        ILogger FLogger;
        #endregion fields & pins

        //called when data for any output pin is requested
        public void Evaluate(int SpreadMax)
        {

            if ((FValueIn.IsChanged || FNameIn.IsChanged) && FValueIn[0] != "")
            {
                FValueIn.SliceCount = SpreadMax;
                debugOut.SliceCount = 1;
                FLogger.Log(LogType.Debug,"setting");
                


                for (int i = 0; i < FValueIn.SliceCount; i++ )
                {
                    if (!ControlManager.stringDict.ContainsKey(FNameIn[i]))
                    {

                        ControlSetString conSet = new ControlSetString();
                        ControlManager.stringDict.Add(FNameIn[0], conSet);
                        ((ControlSetString)ControlManager.stringDict[FNameIn[0]]).setEntry(i, FValueIn[i], FNameIn[0]);
                        

                    }
                    else
                    {
                       ((ControlSetString)ControlManager.stringDict[FNameIn[i]]).setEntry(i, FValueIn[i], FNameIn[0]);

                    }
                    debugOut[0] = "allGood";
                }

            }
        }
    }

}
