﻿#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
    #region PluginInfo
    [PluginInfo(Name = "setControlTransform", Category = "controlManager", Help = "Sets a Transform to the ControlManager", Tags = "", AutoEvaluate = true)]
    #endregion PluginInfo
    public class SetControlEntryTransform : IPluginEvaluate
    {
        #region fields & pins
        [Input("TransformIn", DefaultValue = 1.0)]
        IDiffSpread<Matrix4x4> FValueIn;

        [Input("Name", DefaultValue = 1.0)]
        IDiffSpread<string> FNameIn;

        [Output("debug", DefaultValue = 1.0)]
        ISpread<string> debugOut;

        [Import()]
        ILogger FLogger;
        #endregion fields & pins

        //called when data for any output pin is requested
        public void Evaluate(int SpreadMax)
        {

            if ((FValueIn.IsChanged || FNameIn.IsChanged) && FNameIn[0] !="")
            {
                FValueIn.SliceCount = SpreadMax;
                debugOut.SliceCount = 1;
                

               


                for (int i = 0; i < FValueIn.SliceCount; i++)
                {
          
                    


                    if (!ControlManager.transformDict.ContainsKey(FNameIn[i]))
                    {
                        ControlSetTransform conSet = new ControlSetTransform();
                        ControlManager.transformDict.Add(FNameIn[0], conSet);
                        ((ControlSetTransform)ControlManager.transformDict[FNameIn[0]]).setEntry(i, FValueIn[i], FNameIn[0]);
                    }
                    else
                    {
                        ((ControlSetTransform)ControlManager.transformDict[FNameIn[i]]).setEntry(i, FValueIn[i], FNameIn[0]);
                        ((ControlSetTransform)ControlManager.transformDict[FNameIn[i]]).trim(FValueIn.SliceCount);

   
                    }
                    debugOut[0] = "allGood";
                }

            }
        }
    }

}
