﻿#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
    #region PluginInfo
    [PluginInfo(Name = "setControlValue", Category = "controlManager", Help = "Basic template with one value in/out", Tags = "", AutoEvaluate = true)]
    #endregion PluginInfo
    public class SetControlEntryValue : IPluginEvaluate
    {
        #region fields & pins
        [Input("Value", DefaultValue = 1.0)]
        IDiffSpread<double> FValueIn;

        [Input("Name", DefaultValue = 1.0)]
        IDiffSpread<string> FNameIn;

        [Output("debug", DefaultValue = 1.0)]
        ISpread<string> debugOut;




        [Import()]
        ILogger FLogger;
        #endregion fields & pins

        //called when data for any output pin is requested
        public void Evaluate(int SpreadMax)
        {

            if (FValueIn.IsChanged || FNameIn.IsChanged && FNameIn[0] != "")
            {
                FValueIn.SliceCount = SpreadMax;
                debugOut.SliceCount = 1;
                


                for (int i = 0; i < FValueIn.SliceCount; i++)
                {
                    if (!ControlManager.valueDict.ContainsKey(FNameIn[i]))
                    {

                        ControlSetValue conSet = new ControlSetValue();
                        ControlManager.valueDict.Add(FNameIn[0], conSet);
                        ((ControlSetValue)ControlManager.valueDict[FNameIn[0]]).setEntry(i, FValueIn[i], FNameIn[0]);

                    }
                    else
                    {
                        ((ControlSetValue)ControlManager.valueDict[FNameIn[i]]).setEntry(i, FValueIn[i], FNameIn[0]);

                    }

                }
                debugOut[0] = "allGood";


            }   
        }
    }
}
